Prereq: 100
*** ../tcl7.0b1/patchlevel.h	Fri Jun 18 13:56:34 1993
--- patchlevel.h	Mon Jul 19 16:48:25 1993
***************
*** 6,16 ****
   * release or patch release.  It's used to make sure that Tcl
   * patches are applied in the correct order and only to appropriate
   * sources.
-  *
-  * The #define below makes the patch level available from within
-  * Tcl.  The official level used by the "patch" program is immediately
-  * below.  It must use the same number as the #define.
-  * PatchLevel100
   */
  
! #define TCL_PATCH_LEVEL 100
--- 6,11 ----
   * release or patch release.  It's used to make sure that Tcl
   * patches are applied in the correct order and only to appropriate
   * sources.
   */
  
! #define TCL_PATCH_LEVEL 101
*** ../tcl7.0b1/./tclProc.c	Wed Jun 16 16:01:26 1993
--- ./tclProc.c	Sat Jul 17 14:50:32 1993
***************
*** 26,32 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclProc.c,v 1.64 93/06/16 16:01:21 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
--- 26,32 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclProc.c,v 1.65 93/07/17 14:50:15 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
***************
*** 202,220 ****
  				 * if global frame indicated). */
  {
      register Interp *iPtr = (Interp *) interp;
!     int level, result;
      CallFrame *framePtr;
  
-     if (iPtr->varFramePtr == NULL) {
- 	iPtr->result = "already at top level";
- 	return -1;
-     }
- 
      /*
       * Parse string to figure out which level number to go to.
       */
  
      result = 1;
      if (*string == '#') {
  	if (Tcl_GetInt(interp, string+1, &level) != TCL_OK) {
  	    return -1;
--- 202,216 ----
  				 * if global frame indicated). */
  {
      register Interp *iPtr = (Interp *) interp;
!     int curLevel, level, result;
      CallFrame *framePtr;
  
      /*
       * Parse string to figure out which level number to go to.
       */
  
      result = 1;
+     curLevel = (iPtr->varFramePtr == NULL) ? 0 : iPtr->varFramePtr->level;
      if (*string == '#') {
  	if (Tcl_GetInt(interp, string+1, &level) != TCL_OK) {
  	    return -1;
***************
*** 229,237 ****
  	if (Tcl_GetInt(interp, string, &level) != TCL_OK) {
  	    return -1;
  	}
! 	level = iPtr->varFramePtr->level - level;
      } else {
! 	level = iPtr->varFramePtr->level - 1;
  	result = 0;
      }
  
--- 225,233 ----
  	if (Tcl_GetInt(interp, string, &level) != TCL_OK) {
  	    return -1;
  	}
! 	level = curLevel - level;
      } else {
! 	level = curLevel - 1;
  	result = 0;
      }
  
*** ../tcl7.0b1/./tclVar.c	Thu Jul  1 15:26:02 1993
--- ./tclVar.c	Mon Jul 19 08:19:45 1993
***************
*** 29,35 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclVar.c,v 1.40 93/07/01 15:25:58 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
--- 29,35 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclVar.c,v 1.42 93/07/19 08:19:38 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
***************
*** 488,505 ****
      }
  
      /*
-      * Compute how many total bytes will be needed for the
-      * variable (leave space for a separating space between list
-      * elements).
-      */
- 
-     if (flags & TCL_LIST_ELEMENT) {
- 	length = Tcl_ScanElement(newValue, &listFlags) + 1;
-     } else {
- 	length = strlen(newValue);
-     }
- 
-     /*
       * Clear the variable's current value unless this is an
       * append operation.
       */
--- 488,493 ----
***************
*** 1665,1671 ****
      if (otherPtr == NULL) {
  	return TCL_ERROR;
      }
!     hPtr = Tcl_CreateHashEntry(&iPtr->varFramePtr->varTable, myName, &new);
      if (new) {
  	varPtr = NewVar();
  	Tcl_SetHashValue(hPtr, varPtr);
--- 1653,1663 ----
      if (otherPtr == NULL) {
  	return TCL_ERROR;
      }
!     if (iPtr->varFramePtr != NULL) {
! 	hPtr = Tcl_CreateHashEntry(&iPtr->varFramePtr->varTable, myName, &new);
!     } else {
! 	hPtr = Tcl_CreateHashEntry(&iPtr->globalTable, myName, &new);
!     }
      if (new) {
  	varPtr = NewVar();
  	Tcl_SetHashValue(hPtr, varPtr);
*** ../tcl7.0b1/./tclExpr.c	Thu Jul  8 09:59:05 1993
--- ./tclExpr.c	Mon Jul 19 15:21:25 1993
***************
*** 29,35 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclExpr.c,v 1.53 93/07/08 09:58:56 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
--- 29,35 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclExpr.c,v 1.56 93/07/19 15:21:13 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
***************
*** 218,225 ****
--- 218,227 ----
   * libtcl.a has been processed, so Tcl's version won't be used.
   */
  
+ #ifdef NEED_MATHERR
  extern int matherr();
  int (*tclMatherrPtr)() = matherr;
+ #endif
  
  /*
   * Declarations for local procedures to this file:
***************
*** 331,346 ****
      Value *valuePtr;		/* Where to store value information. 
  				 * Caller must have initialized pv field. */
  {
!     char *term;
! 
!     /*
!      * Try to convert the string to a number.
!      */
  
      if (*string != 0) {
  	valuePtr->type = TYPE_INT;
  	errno = 0;
! 	valuePtr->intValue = strtol(string, &term, 0);
  	if (errno == ERANGE) {
  	    /*
  	     * This procedure is sometimes called with string in
--- 333,361 ----
      Value *valuePtr;		/* Where to store value information. 
  				 * Caller must have initialized pv field. */
  {
!     char *term, *p;
  
      if (*string != 0) {
  	valuePtr->type = TYPE_INT;
  	errno = 0;
! 
! 	/*
! 	 * Note: use strtoul instead of strtol for integer conversions
! 	 * to allow full-size unsigned numbers, but don't depend on
! 	 * strtoul to handle sign characters;  it won't in some
! 	 * implementations.
! 	 */
! 
! 	for (p = string; isspace(*p); p++) {
! 	    /* Empty loop body. */
! 	}
! 	if (*p == '-') {
! 	    valuePtr->intValue = -strtoul(p+1, &term, 0);
! 	} else if (*p == '+') {
! 	    valuePtr->intValue = strtoul(p+1, &term, 0);
! 	} else {
! 	    valuePtr->intValue = strtoul(p, &term, 0);
! 	}
  	if (errno == ERANGE) {
  	    /*
  	     * This procedure is sometimes called with string in
***************
*** 358,370 ****
  	    return TCL_OK;
  	}
  	errno = 0;
! 	valuePtr->doubleValue = strtod(string, &term);
! 	if (errno != 0) {
! 	    Tcl_ResetResult(interp);
! 	    ExprFloatError(interp, valuePtr->doubleValue);
! 	    return TCL_ERROR;
! 	}
! 	if (*term == '\0') {
  	    valuePtr->type = TYPE_DOUBLE;
  	    return TCL_OK;
  	}
--- 373,385 ----
  	    return TCL_OK;
  	}
  	errno = 0;
! 	valuePtr->doubleValue = strtod(p, &term);
! 	if ((term != p) && (*term == '\0')) {
! 	    if (errno != 0) {
! 		Tcl_ResetResult(interp);
! 		ExprFloatError(interp, valuePtr->doubleValue);
! 		return TCL_ERROR;
! 	    }
  	    valuePtr->type = TYPE_DOUBLE;
  	    return TCL_OK;
  	}
***************
*** 463,473 ****
      
  	    errno = 0;
  	    valuePtr->doubleValue = strtod(p, &term2);
- 	    if (errno != 0) {
- 		ExprFloatError(interp, valuePtr->doubleValue);
- 		return TCL_ERROR;
- 	    }
  	    if (term2 != p) {
  		infoPtr->token = VALUE;
  		infoPtr->expr = term2;
  		valuePtr->type = TYPE_DOUBLE;
--- 478,488 ----
      
  	    errno = 0;
  	    valuePtr->doubleValue = strtod(p, &term2);
  	    if (term2 != p) {
+ 		if (errno != 0) {
+ 		    ExprFloatError(interp, valuePtr->doubleValue);
+ 		    return TCL_ERROR;
+ 		}
  		infoPtr->token = VALUE;
  		infoPtr->expr = term2;
  		valuePtr->type = TYPE_DOUBLE;
*** ../tcl7.0b1/./tclGet.c	Sat Feb  6 16:20:35 1993
--- ./tclGet.c	Mon Jul 12 11:35:29 1993
***************
*** 27,33 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclGet.c,v 1.12 93/02/06 16:20:34 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  #include "tclInt.h"
--- 27,33 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclGet.c,v 1.13 93/07/12 11:35:14 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  #include "tclInt.h"
***************
*** 58,67 ****
  				 * integer in a form acceptable to strtol. */
      int *intPtr;		/* Place to store converted result. */
  {
!     char *end;
      int i;
  
!     i = strtol(string, &end, 0);
      while ((*end != '\0') && isspace(*end)) {
  	end++;
      }
--- 58,82 ----
  				 * integer in a form acceptable to strtol. */
      int *intPtr;		/* Place to store converted result. */
  {
!     char *end, *p;
      int i;
  
!     /*
!      * Note: use strtoul instead of strtol for integer conversions
!      * to allow full-size unsigned numbers, but don't depend on strtoul
!      * to handle sign characters;  it won't in some implementations.
!      */
! 
!     for (p = string; isspace(*p); p++) {
! 	/* Empty loop body. */
!     }
!     if (*p == '-') {
! 	i = -strtoul(p+1, &end, 0);
!     } else if (*p == '+') {
! 	i = strtoul(p+1, &end, 0);
!     } else {
! 	i = strtoul(p, &end, 0);
!     }
      while ((*end != '\0') && isspace(*end)) {
  	end++;
      }
*** ../tcl7.0b1/./panic.c	Sat Feb  6 16:20:44 1993
--- ./panic.c	Mon Jul 12 14:01:40 1993
***************
*** 27,37 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/panic.c,v 1.4 93/02/06 16:20:43 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include <stdio.h>
! #include <stdlib.h>
  
  /*
   *----------------------------------------------------------------------
--- 27,41 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/panic.c,v 1.5 93/07/12 14:01:35 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include <stdio.h>
! #ifdef NO_STDLIB_H
! #   include "compat/stdlib.h"
! #else
! #   include <stdlib.h>
! #endif
  
  /*
   *----------------------------------------------------------------------
*** ../tcl7.0b1/./tclEnv.c	Thu Jul  8 09:59:28 1993
--- ./tclEnv.c	Mon Jul 19 10:05:56 1993
***************
*** 26,44 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclEnv.c,v 1.14 93/07/08 09:59:27 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  /*
!  * The putenv definition below causes any system prototype for putenv
!  * to be ignored so that there won't be a clash when the version of
!  * putenv in this file is compiled.
   */
  
  #define putenv ignore_putenv
  #include "tclInt.h"
  #include "tclUnix.h"
  #undef putenv
  
  /*
   * The structure below is used to keep track of all of the interpereters
--- 26,46 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclEnv.c,v 1.16 93/07/19 10:05:42 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  /*
!  * The putenv and setenv definitions below cause any system prototypes for
!  * those procedures to be ignored so that there won't be a clash when the
!  * versions in this file are compiled.
   */
  
  #define putenv ignore_putenv
+ #define setenv ignore_setenv
  #include "tclInt.h"
  #include "tclUnix.h"
  #undef putenv
+ #undef setenv
  
  /*
   * The structure below is used to keep track of all of the interpereters
***************
*** 76,84 ****
  			    int flags));
  static int		FindVariable _ANSI_ARGS_((CONST char *name,
  			    int *lengthPtr));
! void			setenv _ANSI_ARGS_((CONST char *name,
  			    CONST char *value));
! void			unsetenv _ANSI_ARGS_((CONST char *name));
  
  /*
   *----------------------------------------------------------------------
--- 78,86 ----
  			    int flags));
  static int		FindVariable _ANSI_ARGS_((CONST char *name,
  			    int *lengthPtr));
! void			TclSetEnv _ANSI_ARGS_((CONST char *name,
  			    CONST char *value));
! void			TclUnsetEnv _ANSI_ARGS_((CONST char *name));
  
  /*
   *----------------------------------------------------------------------
***************
*** 202,212 ****
  /*
   *----------------------------------------------------------------------
   *
!  * setenv --
   *
   *	Set an environment variable, replacing an existing value
   *	or creating a new variable if there doesn't exist a variable
!  *	by the given name.
   *
   * Results:
   *	None.
--- 204,217 ----
  /*
   *----------------------------------------------------------------------
   *
!  * TclSetEnv --
   *
   *	Set an environment variable, replacing an existing value
   *	or creating a new variable if there doesn't exist a variable
!  *	by the given name.  This procedure is intended to be a
!  *	stand-in for the  UNIX "setenv" procedure so that applications
!  *	using that procedure will interface properly to Tcl.  To make
!  *	it a stand-in, the Makefile must define "TclSetEnv" to "setenv".
   *
   * Results:
   *	None.
***************
*** 219,225 ****
   */
  
  void
! setenv(name, value)
      CONST char *name;		/* Name of variable whose value is to be
  				 * set. */
      CONST char *value;		/* New value for variable. */
--- 224,230 ----
   */
  
  void
! TclSetEnv(name, value)
      CONST char *name;		/* Name of variable whose value is to be
  				 * set. */
      CONST char *value;		/* New value for variable. */
***************
*** 294,307 ****
  /*
   *----------------------------------------------------------------------
   *
!  * putenv --
   *
   *	Set an environment variable.  Similar to setenv except that
   *	the information is passed in a single string of the form
   *	NAME=value, rather than as separate name strings.  This procedure
!  *	is a stand-in for the standard UNIX procedure by the same name,
   *	so that applications using that procedure will interface
!  *	properly to Tcl.
   *
   * Results:
   *	None.
--- 299,313 ----
  /*
   *----------------------------------------------------------------------
   *
!  * Tcl_PutEnv --
   *
   *	Set an environment variable.  Similar to setenv except that
   *	the information is passed in a single string of the form
   *	NAME=value, rather than as separate name strings.  This procedure
!  *	is intended to be a stand-in for the  UNIX "putenv" procedure
   *	so that applications using that procedure will interface
!  *	properly to Tcl.  To make it a stand-in, the Makefile will
!  *	define "Tcl_PutEnv" to "putenv".
   *
   * Results:
   *	None.
***************
*** 314,320 ****
   */
  
  int
! putenv(string)
      CONST char *string;		/* Info about environment variable in the
  				 * form NAME=value. */
  {
--- 320,326 ----
   */
  
  int
! Tcl_PutEnv(string)
      CONST char *string;		/* Info about environment variable in the
  				 * form NAME=value. */
  {
***************
*** 327,333 ****
  
      /*
       * Separate the string into name and value parts, then call
!      * setenv to do all of the real work.
       */
  
      value = strchr(string, '=');
--- 333,339 ----
  
      /*
       * Separate the string into name and value parts, then call
!      * TclSetEnv to do all of the real work.
       */
  
      value = strchr(string, '=');
***************
*** 341,347 ****
      name = ckalloc((unsigned) nameLength+1);
      memcpy(name, string, nameLength);
      name[nameLength] = 0;
!     setenv(name, value+1);
      ckfree(name);
      return 0;
  }
--- 347,353 ----
      name = ckalloc((unsigned) nameLength+1);
      memcpy(name, string, nameLength);
      name[nameLength] = 0;
!     TclSetEnv(name, value+1);
      ckfree(name);
      return 0;
  }
***************
*** 349,358 ****
  /*
   *----------------------------------------------------------------------
   *
!  * unsetenv --
   *
   *	Remove an environment variable, updating the "env" arrays
!  *	in all interpreters managed by us.
   *
   * Results:
   *	None.
--- 355,367 ----
  /*
   *----------------------------------------------------------------------
   *
!  * TclUnsetEnv --
   *
   *	Remove an environment variable, updating the "env" arrays
!  *	in all interpreters managed by us.  This function is intended
!  *	to replace the UNIX "unsetenv" function (but to do this the
!  *	Makefile must be modified to redefine "TclUnsetEnv" to
!  *	"unsetenv".
   *
   * Results:
   *	None.
***************
*** 364,370 ****
   */
  
  void
! unsetenv(name)
      CONST char *name;			/* Name of variable to remove. */
  {
      int index, dummy;
--- 373,379 ----
   */
  
  void
! TclUnsetEnv(name)
      CONST char *name;			/* Name of variable to remove. */
  {
      int index, dummy;
***************
*** 466,480 ****
      }
  
      /*
!      * If a value is being set, call setenv to do all of the work.
       */
  
      if (flags & TCL_TRACE_WRITES) {
! 	setenv(name2, Tcl_GetVar2(interp, "env", name2, TCL_GLOBAL_ONLY));
      }
  
      if (flags & TCL_TRACE_UNSETS) {
! 	unsetenv(name2);
      }
      return NULL;
  }
--- 475,489 ----
      }
  
      /*
!      * If a value is being set, call TclSetEnv to do all of the work.
       */
  
      if (flags & TCL_TRACE_WRITES) {
! 	TclSetEnv(name2, Tcl_GetVar2(interp, "env", name2, TCL_GLOBAL_ONLY));
      }
  
      if (flags & TCL_TRACE_UNSETS) {
! 	TclUnsetEnv(name2);
      }
      return NULL;
  }
*** ../tcl7.0b1/./tclMtherr.c	Thu Jun  3 10:36:37 1993
--- ./tclMtherr.c	Mon Jul 19 15:21:09 1993
***************
*** 26,38 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclMtherr.c,v 1.3 93/06/03 10:36:22 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  #include "tclInt.h"
- #ifndef TCL_NO_MATH
  #include <math.h>
- #endif
  
  /*
   * The stuff below is a bit of a hack so that this file can be used
--- 26,36 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclMtherr.c,v 1.4 93/07/19 14:58:45 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  #include "tclInt.h"
  #include <math.h>
  
  /*
   * The stuff below is a bit of a hack so that this file can be used
***************
*** 57,76 ****
  
  extern int tcl_MathInProgress;
  
- /*
-  * Define a dummy "struct exception" structure if none already exists.
-  * The "OVERFLOW" #define is tested to see whether matherr stuff has
-  * been defined in math.h (struct exception is only defined if the
-  * matherr stuff is defined).
-  */
- 
- #ifndef OVERFLOW
- struct exception {
-     int type;
- };
- #define DOMAIN 0
- #define SING 1
- #endif
  
  /*
   *----------------------------------------------------------------------
--- 55,60 ----
*** ../tcl7.0b1/./tclCmdAH.c	Thu Jun 17 15:23:35 1993
--- ./tclCmdAH.c	Sat Jul 17 15:25:38 1993
***************
*** 27,33 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclCmdAH.c,v 1.89 93/06/17 11:23:06 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
--- 27,33 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclCmdAH.c,v 1.90 93/07/17 15:25:20 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
***************
*** 835,851 ****
  	    goto badIndex;
  	}
  	switch (*format) {
! 	    case 'D':
! 	    case 'O':
! 	    case 'U':
! 		if (!useShort) {
! 		    newPtr++;
! 		} else {
! 		    useShort = 0;
! 		}
! 		newPtr[-1] = tolower(*format);
! 		newPtr[-2] = 'l';
! 		*newPtr = 0;
  	    case 'd':
  	    case 'o':
  	    case 'u':
--- 835,842 ----
  	    goto badIndex;
  	}
  	switch (*format) {
! 	    case 'i':
! 		newPtr[-1] = 'd';
  	    case 'd':
  	    case 'o':
  	    case 'u':
***************
*** 868,875 ****
  		}
  		size = 1;
  		break;
- 	    case 'F':
- 		newPtr[-1] = tolower(newPtr[-1]);
  	    case 'e':
  	    case 'E':
  	    case 'f':
--- 859,864 ----
*** ../tcl7.0b1/./tclCmdMZ.c	Thu Jun 17 13:33:35 1993
--- ./tclCmdMZ.c	Fri Jul 16 16:51:35 1993
***************
*** 28,34 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclCmdMZ.c,v 1.32 93/06/17 13:33:28 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
--- 28,34 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/RCS/tclCmdMZ.c,v 1.34 93/07/16 16:50:50 ouster Exp $ SPRITE (Berkeley)";
  #endif
  
  #include "tclInt.h"
***************
*** 536,565 ****
      char **argv;			/* Argument strings. */
  {
      Interp *iPtr = (Interp *) interp;
!     int c;
  
!     if (argc > 3) {
  	Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0],
! 		" ?value? ?code?\"", (char *) NULL);
  	return TCL_ERROR;
      }
!     if (argc >= 2) {
! 	Tcl_SetResult(interp, argv[1], TCL_VOLATILE);
!     }
!     iPtr->returnCode = TCL_OK;
!     if (argc == 3) {
  	c = argv[2][0];
  	if ((c == 'o') && (strcmp(argv[2], "ok") == 0)) {
! 	    iPtr->returnCode = TCL_OK;
  	} else if ((c == 'e') && (strcmp(argv[2], "error") == 0)) {
! 	    iPtr->returnCode = TCL_ERROR;
  	} else if ((c == 'r') && (strcmp(argv[2], "return") == 0)) {
! 	    iPtr->returnCode = TCL_RETURN;
  	} else if ((c == 'b') && (strcmp(argv[2], "break") == 0)) {
! 	    iPtr->returnCode = TCL_BREAK;
  	} else if ((c == 'c') && (strcmp(argv[2], "continue") == 0)) {
! 	    iPtr->returnCode = TCL_CONTINUE;
! 	} else if (Tcl_GetInt(interp, argv[2], &iPtr->returnCode) != TCL_OK) {
  	    Tcl_ResetResult(interp);
  	    Tcl_AppendResult(interp, "bad completion code \"",
  		    argv[2], "\": must be ok, error, return, break, ",
--- 536,566 ----
      char **argv;			/* Argument strings. */
  {
      Interp *iPtr = (Interp *) interp;
!     int c, code;
  
!     if (argc > 4) {
! 	syntaxError:
  	Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0],
! 		" ?-code code? ?string?\"", (char *) NULL);
  	return TCL_ERROR;
      }
!     code = TCL_OK;
!     if (argc >= 3) {
! 	if (strcmp(argv[1], "-code") != 0) {
! 	    goto syntaxError;
! 	}
  	c = argv[2][0];
  	if ((c == 'o') && (strcmp(argv[2], "ok") == 0)) {
! 	    code = TCL_OK;
  	} else if ((c == 'e') && (strcmp(argv[2], "error") == 0)) {
! 	    code = TCL_ERROR;
  	} else if ((c == 'r') && (strcmp(argv[2], "return") == 0)) {
! 	    code = TCL_RETURN;
  	} else if ((c == 'b') && (strcmp(argv[2], "break") == 0)) {
! 	    code = TCL_BREAK;
  	} else if ((c == 'c') && (strcmp(argv[2], "continue") == 0)) {
! 	    code = TCL_CONTINUE;
! 	} else if (Tcl_GetInt(interp, argv[2], &code) != TCL_OK) {
  	    Tcl_ResetResult(interp);
  	    Tcl_AppendResult(interp, "bad completion code \"",
  		    argv[2], "\": must be ok, error, return, break, ",
***************
*** 566,573 ****
  		    "continue, or an integer", (char *) NULL);
  	    return TCL_ERROR;
  	}
      }
! 
      return TCL_RETURN;
  }
  
--- 567,579 ----
  		    "continue, or an integer", (char *) NULL);
  	    return TCL_ERROR;
  	}
+ 	if (argc == 4) {
+ 	    Tcl_SetResult(interp, argv[3], TCL_VOLATILE);
+ 	}
+     } else if (argc == 2) {
+ 	Tcl_SetResult(interp, argv[1], TCL_VOLATILE);
      }
!     iPtr->returnCode = code;
      return TCL_RETURN;
  }
  
***************
*** 615,625 ****
  					 * suppressed. */
      int totalSize = 0;			/* Number of bytes needed to store
  					 * all results combined. */
!     char *results;			/* Where scanned output goes.  */
      int numScanned;			/* sscanf's result. */
      register char *fmt;
!     int i, widthSpecified;
  
      if (argc < 3) {
  	Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0],
  		" string format ?varName varName ...?\"", (char *) NULL);
--- 621,643 ----
  					 * suppressed. */
      int totalSize = 0;			/* Number of bytes needed to store
  					 * all results combined. */
!     char *results;			/* Where scanned output goes.
! 					 * Malloced; NULL means not allocated
! 					 * yet. */
      int numScanned;			/* sscanf's result. */
      register char *fmt;
!     int i, widthSpecified, length, code;
! 
!     /*
!      * The variables below are used to hold a copy of the format
!      * string, so that we can replace format specifiers like "%f"
!      * and "%F" with specifiers like "%lf"
!      */
  
+ #   define STATIC_SIZE 5
+     char copyBuf[STATIC_SIZE], *fmtCopy;
+     register char *dst;
+ 
      if (argc < 3) {
  	Tcl_AppendResult(interp, "wrong # args: should be \"", argv[0],
  		" string format ?varName varName ...?\"", (char *) NULL);
***************
*** 635,651 ****
--- 653,684 ----
       * 4. Pick off the fields from the array and assign them to variables.
       */
  
+     code = TCL_OK;
+     results = NULL;
      arg1Length = (strlen(argv[1]) + 4) & ~03;
+     length = strlen(argv[2]) * 2 + 1;
+     if (length < STATIC_SIZE) {
+ 	fmtCopy = copyBuf;
+     } else {
+ 	fmtCopy = ckalloc((unsigned) length);
+     }
+     dst = fmtCopy;
      for (fmt = argv[2]; *fmt != 0; fmt++) {
+ 	*dst = *fmt;
+ 	dst++;
  	if (*fmt != '%') {
  	    continue;
  	}
  	fmt++;
  	if (*fmt == '%') {
+ 	    *dst = *fmt;
+ 	    dst++;
  	    continue;
  	}
  	if (*fmt == '*') {
  	    suppress = 1;
+ 	    *dst = *fmt;
+ 	    dst++;
  	    fmt++;
  	} else {
  	    suppress = 0;
***************
*** 653,674 ****
  	widthSpecified = 0;
  	while (isdigit(*fmt)) {
  	    widthSpecified = 1;
  	    fmt++;
  	}
  	if (suppress) {
  	    continue;
  	}
  	if (numFields == MAX_FIELDS) {
  	    interp->result = "too many fields to scan";
! 	    return TCL_ERROR;
  	}
  	curField = &fields[numFields];
  	numFields++;
  	switch (*fmt) {
- 	    case 'D':
- 	    case 'O':
- 	    case 'X':
  	    case 'd':
  	    case 'o':
  	    case 'x':
  		curField->fmt = 'd';
--- 686,713 ----
  	widthSpecified = 0;
  	while (isdigit(*fmt)) {
  	    widthSpecified = 1;
+ 	    *dst = *fmt;
+ 	    dst++;
+ 	    fmt++;
+ 	}
+ 	if ((*fmt == 'l') || (*fmt == 'h') || (*fmt == 'L')) {
  	    fmt++;
  	}
+ 	*dst = *fmt;
+ 	dst++;
  	if (suppress) {
  	    continue;
  	}
  	if (numFields == MAX_FIELDS) {
  	    interp->result = "too many fields to scan";
! 	    code = TCL_ERROR;
! 	    goto done;
  	}
  	curField = &fields[numFields];
  	numFields++;
  	switch (*fmt) {
  	    case 'd':
+ 	    case 'i':
  	    case 'o':
  	    case 'x':
  		curField->fmt = 'd';
***************
*** 675,680 ****
--- 714,724 ----
  		curField->size = sizeof(int);
  		break;
  
+ 	    case 'u':
+ 		curField->fmt = 'u';
+ 		curField->size = sizeof(int);
+ 		break;
+ 
  	    case 's':
  		curField->fmt = 's';
  		curField->size = arg1Length;
***************
*** 684,705 ****
                  if (widthSpecified) {
                      interp->result = 
                           "field width may not be specified in %c conversion";
!                     return TCL_ERROR;
                  }
  		curField->fmt = 'c';
  		curField->size = sizeof(int);
  		break;
  
- 	    case 'E':
- 	    case 'F':
- 		curField->fmt = 'F';
- 		curField->size = sizeof(double);
- 		break;
- 
  	    case 'e':
  	    case 'f':
  		curField->fmt = 'f';
! 		curField->size = sizeof(float);
  		break;
  
  	    case '[':
--- 728,748 ----
                  if (widthSpecified) {
                      interp->result = 
                           "field width may not be specified in %c conversion";
! 		    code = TCL_ERROR;
! 		    goto done;
                  }
  		curField->fmt = 'c';
  		curField->size = sizeof(int);
  		break;
  
  	    case 'e':
  	    case 'f':
+ 	    case 'g':
+ 		dst[-1] = 'l';
+ 		dst[0] = 'f';
+ 		dst++;
  		curField->fmt = 'f';
! 		curField->size = sizeof(double);
  		break;
  
  	    case '[':
***************
*** 707,712 ****
--- 750,757 ----
  		curField->size = arg1Length;
  		do {
  		    fmt++;
+ 		    *dst = *fmt;
+ 		    dst++;
  		} while (*fmt != ']');
  		break;
  
***************
*** 713,727 ****
  	    default:
  		sprintf(interp->result, "bad scan conversion character \"%c\"",
  			*fmt);
! 		return TCL_ERROR;
  	}
  	totalSize += curField->size;
      }
  
      if (numFields != (argc-3)) {
  	interp->result =
  		"different numbers of variable names and field specifiers";
! 	return TCL_ERROR;
      }
  
      /*
--- 758,775 ----
  	    default:
  		sprintf(interp->result, "bad scan conversion character \"%c\"",
  			*fmt);
! 		code = TCL_ERROR;
! 		goto done;
  	}
  	totalSize += curField->size;
      }
+     *dst = 0;
  
      if (numFields != (argc-3)) {
  	interp->result =
  		"different numbers of variable names and field specifiers";
! 	code = TCL_ERROR;
! 	goto done;
      }
  
      /*
***************
*** 749,755 ****
       * Step 3:
       */
  
!     numScanned = sscanf(argv[1], argv[2],
  	    fields[0].location, fields[1].location, fields[2].location,
  	    fields[3].location, fields[4].location, fields[5].location,
  	    fields[6].location, fields[7].location, fields[8].location,
--- 797,803 ----
       * Step 3:
       */
  
!     numScanned = sscanf(argv[1], fmtCopy,
  	    fields[0].location, fields[1].location, fields[2].location,
  	    fields[3].location, fields[4].location, fields[5].location,
  	    fields[6].location, fields[7].location, fields[8].location,
***************
*** 776,783 ****
  		    Tcl_AppendResult(interp,
  			    "couldn't set variable \"", argv[i+3], "\"",
  			    (char *) NULL);
! 		    ckfree((char *) results);
! 		    return TCL_ERROR;
  		}
  		break;
  
--- 824,838 ----
  		    Tcl_AppendResult(interp,
  			    "couldn't set variable \"", argv[i+3], "\"",
  			    (char *) NULL);
! 		    code = TCL_ERROR;
! 		    goto done;
! 		}
! 		break;
! 
! 	    case 'u':
! 		sprintf(string, "%u", *((int *) curField->location));
! 		if (Tcl_SetVar(interp, argv[i+3], string, 0) == NULL) {
! 		    goto storeError;
  		}
  		break;
  
***************
*** 795,810 ****
  		}
  		break;
  
- 	    case 'F':
- 		Tcl_PrintDouble(interp, *((double *) curField->location),
- 			string);
- 		if (Tcl_SetVar(interp, argv[i+3], string, 0) == NULL) {
- 		    goto storeError;
- 		}
- 		break;
- 
  	    case 'f':
! 		Tcl_PrintDouble(interp, *((float *) curField->location),
  			string);
  		if (Tcl_SetVar(interp, argv[i+3], string, 0) == NULL) {
  		    goto storeError;
--- 850,857 ----
  		}
  		break;
  
  	    case 'f':
! 		Tcl_PrintDouble(interp, *((double *) curField->location),
  			string);
  		if (Tcl_SetVar(interp, argv[i+3], string, 0) == NULL) {
  		    goto storeError;
***************
*** 812,820 ****
  		break;
  	}
      }
-     ckfree(results);
      sprintf(interp->result, "%d", numScanned);
!     return TCL_OK;
  }
  
  /*
--- 859,873 ----
  		break;
  	}
      }
      sprintf(interp->result, "%d", numScanned);
!     done:
!     if (results != NULL) {
! 	ckfree(results);
!     }
!     if (fmtCopy != copyBuf) {
! 	ckfree(fmtCopy);
!     }
!     return code;
  }
  
  /*
*** ../tcl7.0b1/./tclCkalloc.c	Thu Jun  3 15:08:02 1993
--- ./tclCkalloc.c	Thu Jul 15 16:42:56 1993
***************
*** 260,271 ****
      }
  
      /*
!      * Fill in guard zones and size.  Link into allocated list.
       */
      result->length = size;
      result->file = file;
      result->line = line;
      memset ((char *) result->low_guard, GUARD_VALUE, GUARD_SIZE);
      memset (result->body + size, GUARD_VALUE, GUARD_SIZE);
      result->flink = allocHead;
      result->blink = NULL;
--- 260,274 ----
      }
  
      /*
!      * Fill in guard zones and size.  Also initialize the contents of
!      * the block with bogus bytes to detect uses of initialized data.
!      * Link into allocated list.
       */
      result->length = size;
      result->file = file;
      result->line = line;
      memset ((char *) result->low_guard, GUARD_VALUE, GUARD_SIZE);
+     memset (result->body, GUARD_VALUE, size);
      memset (result->body + size, GUARD_VALUE, GUARD_SIZE);
      result->flink = allocHead;
      result->blink = NULL;
